//****************************************************************************
//
// CCfile: Cverklist.cc
//
// Autor: A. Kipp
// erstellt: Wed Mar  1 10:20:59 1995 
// veraendert:
//
// Enthaelt: 
//****************************************************************************
#include "Cverklist.h"
#include "CCexceptions.h"

//***************************************************************************
// Implementierung der Klasse: Cverklist
// Autor: A. Kipp
// erstellt: Wed Mar  1 10:20:59 1995 
// veraendert:
//***************************************************************************
template<class T> Cverklist<T>::Cverklist()
  {
  anzel = 0;
  addhere = &anker;
  anker = NULL;
  acsptr=anker;
  }
  
template<class T> T* Cverklist<T>::addEl(T* el)
  {
  T* ptr;
  *addhere = new Clistel<T>;
  if( *addhere == 0 )
    {
    exit(1);
    }
    
  memcpy( (char*)(&(*addhere)->data),(char*)el,sizeof(T));
  ptr = &(*addhere)->data;
  addhere = &(*addhere)->next;
  anzel++;
  return ptr;
  }

template<class T> T* Cverklist<T>::addIniEl(T* el)
  {
  T* ptr;
  Clistel<T> *nel = new Clistel<T>;
  if( nel == 0 )
    {
    exit(1);
    }
    
  memcpy( (char*)(&nel->data),(char*)el,sizeof(T));
  ptr = &nel->data;
  nel->next=anker;
  anker=nel;
  anzel++;
  return ptr;
  }  
template<class T>  void Cverklist<T>::delElIndx(int index)
  {
  int i;
  Clistel<T> *akt = anker;
  for( i=0 ; i<index ; i++,akt=akt->next )
    {
    if( akt == NULL )
      {
      exit(1);
      }
    }
    
  deleteVlistEl(akt);
  }
  
template<class T> void Cverklist<T>::clear()
  {
  Clistel<T>* rmnext;
  
  for( ;anker != NULL ; )
    {
    rmnext = anker->next;
    delete anker;
    anker = rmnext;
    }
  anker = NULL;
  anzel = 0;
  addhere = &anker;
  }

template<class T> void Cverklist<T>::deleteVlistEl(Clistel<T>* le)
  {
  Clistel<T>* rm = le->next;
  int i;
  if( rm != NULL )
    {
    memcpy( (char*)(le) , (char*)(rm) , sizeof(Clistel<T>));
    delete rm;
    }
  else
    {
    delete le;
    //addhere richten    
    }
  
  anzel--;
  for( addhere=&anker, i=0 ; i < anzel ; addhere = &((*addhere)->next),i++ );
  *addhere = NULL;
  }

template<class T>  T* Cverklist<T>::skipThru(vlist_cntl cntl)
  {
  switch( cntl )
    {
    case init:
      acsptr = anker;
      break;
    case next:
      acsptr = acsptr==NULL ? NULL : acsptr->next;
      break;
    }
  return acsptr==NULL ? NULL : &(acsptr->data);
  }

template<class T> T& Cverklist<T>::operator[](int index)
  {
  int i=0;
  Clistel<T> *akt = anker;
  
  for( i=0,akt=anker ; i<index ; i++,akt=akt->next )
    {
    if( akt == NULL )
      {
      exit(1);
      }
    }
  return akt->data;
  }
 
template<class T> int Cverklist<T>::compact(T** ptr)
  {
  int i;
  Clistel<T> *akt = anker;
  *ptr = new T[anzel];
  
  if( *ptr == 0 )
    {
    exit(1);
    }
    
  for( i=0 ; akt != NULL ; akt=akt->next,i++ )
    {
    memcpy( (char*)(*ptr + i) , (char*)(&akt->data) , sizeof(T));
    }
    
  return anzel;
  }
